// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the DHHALLIB_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// DHHALLIB_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.

/*
// Copyright (c) DH electronics GmbH.  All rights reserved.
//
//------------------------------------------------------------------------------
//
//  File: DHHalLib.h
//
//  Version:  1.1.0.1
//
//  Abstract: Declaration of the public functions of the DHHalLib.dll.
//
//  Notes:
//		Created by: 	Andreas Geisreiter
//  	Created: 		September 06, 2012
//		Modified by:	Christian Apfel
//		Modified:		June 09, 2017
//
//----------------------------------------------------------------------------*/


#ifndef DHHALLIB_H
#define DHHALLIB_H

//#ifdef cplusplus
#ifdef DHHALLIB_EXPORTS
#define DHHALLIB_API extern "C"  __declspec(dllexport)
#else
#define DHHALLIB_API extern "C" __declspec(dllimport)
#endif
//#else
//#ifdef DHHALLIB_EXPORTS
//#define DHHALLIB_API __declspec(dllexport);
//#else
//#define DHHALLIB_API __declspec(dllimport);
//#endif
//#endif

typedef enum DHCOM_GPIOEnum
{
   DHCOM_GPIO_A=1,
   DHCOM_GPIO_B,
   DHCOM_GPIO_C,
   DHCOM_GPIO_D,
   DHCOM_GPIO_E,
   DHCOM_GPIO_F,
   DHCOM_GPIO_G,
   DHCOM_GPIO_H,
   DHCOM_GPIO_I,
   DHCOM_GPIO_J,
   DHCOM_GPIO_K,
   DHCOM_GPIO_L,
   DHCOM_GPIO_M,
   DHCOM_GPIO_N,
   DHCOM_GPIO_O,
   DHCOM_GPIO_P,
   DHCOM_GPIO_Q,
   DHCOM_GPIO_R,
   DHCOM_GPIO_S,
   DHCOM_GPIO_T,
   DHCOM_GPIO_U,
   DHCOM_GPIO_V,
   DHCOM_GPIO_W,
   DHCOM_GPIO_UART1_CTS,
   DHCOM_GPIO_UART1_RTS,
   DHCOM_GPIO_UART2_CTS,
   DHCOM_GPIO_UART2_RTS,
   DHCOM_GPIO_PWM,
   DHCOM_GPIO_INT_PRIO,
   DHCOM_GPIO_NOT_DEFINED
}*pDHCOM_GPIOEnum;

typedef enum GPIOConvertType
{
	DHCOM_GPIO_ID=0,
	DHCOM_GPIO_PORT,
	DHCOM_GPIO_PIN
}*pGPIOConvertType;

typedef enum DHCOM_GPIOISRType
{
	DHCOM_GPIO_INTR_LOW_LEV=0,
	DHCOM_GPIO_INTR_HIGH_LEV,
	DHCOM_GPIO_INTR_RISE_EDGE,
	DHCOM_GPIO_INTR_FALL_EDGE,
	DHCOM_GPIO_INTR_BOTH_EDGE,
	DHCOM_GPIO_INTR_NONE
}*pDHCOM_GPIOISRType;

typedef enum DHCOM_I2CEnum
{
	DHCOM_I2C0=0,
	DHCOM_I2C1,
	DHCOM_I2C2,
	DHCOM_I2C3,
	/*DHCOM_I2C4,*/
	DHCOM_I2C_NOT_DEFINED
}*pDHCOM_I2CEnum;

typedef enum DHCOM_I2CFREQMode
{
	I2C_100K=0,
	I2C_400K,
	I2C_800K,
	I2C_1600K,
	I2C_2400K,
	I2C_3200K
}*pDHCOM_I2CFREQMode;

typedef enum DHCOM_SPIEnum
{
	DHCOM_SPI1=0,
	DHCOM_SPI2,
	DHCOM_SPI_NOT_DEFINED
}*pDHCOM_SPIEnum;

//typedef enum DHCOM_SPIChannelEnum
//{
//	SPI_CH0=0,
//	SPI_CH1,
//	SPI_CH2,
//	SPI_CH3
//}*pDHCOM_SPIChannelEnum;

typedef enum DHCOM_SPIModeEnum
{
	SPI_CS0=0,
	SPI_CS1,
	SPI_CS2,
	SPI_CS3
}*pDHCOM_SPIModeEnum;

typedef enum DHCOM_PHYEnum
{
	DHCOM_PHY1=1,
	DHCOM_PHY2,
	DHCOM_PHY3,
	DHCOM_PHY4,
	DHCOM_PHY5,
	DHCOM_PHY6,
	DHCOM_PHY7,
	DHCOM_PHY8,
	DHCOM_PHY9
}*pDHCOM_PHYEnum;

typedef enum DHCOM_UARTEnum
{
	DHCOM_UART1=1,
	DHCOM_UART2,
	DHCOM_UART3,
	DHCOM_UART4,
	DHCOM_UART5,
	DHCOM_UART6,
	DHCOM_UART7,
	DHCOM_UART8,
	DHCOM_UART9
}*pDHCOM_UARTEnum;

typedef enum DHCOM_UARTModeEnum
{
	DHCOM_HSHAKE_OFF=0,
	DHCOM_HSHAKE_SOFTWARE,
	DHCOM_HSHAKE_HARDWARE
}*pDHCOM_UARTModeEnum;

typedef enum DHCOM_UARTParityEnum
{
	DHCOM_NOPARITY=0,
	DHCOM_ODDPARITY,
	DHCOM_EVENPARITY,
	DHCOM_MARKPARITY,
	DHCOM_SPACEPARITY
}*pDHCOM_UARTParityEnum;

typedef enum DHCOM_UARTStopBitEnum
{
	DHCOM_ONESTOPBIT=0,
	DHCOM_ONE5STOPBITS,
	DHCOM_TWOSTOPBITS
}*pDHCOM_UARTStopBitEnum;

typedef enum DHCOM_UARTByteSizeEnum
{
	DHCOM_5BIT=5,
	DHCOM_6BIT,
	DHCOM_7BIT,
	DHCOM_8BIT
}*pDHCOM_UARTByteSizeEnum;

typedef enum DHCOM_UARTWEvent
{
	SIG_RX_CHAR_DETECT_Flag=1,
	SIG_RX_EVENT_DETECT_Flag=2,
	SIG_TX_BUFFER_EMPTY_Flag=4,
	SIG_CTS_CHANGED_Flag=8,
	SIG_DSR_CHANGED_Flag=16,
	SIG_RLSD_CHANGED_Flag=32,
	SIG_BREAK_DETECT_Error=64,
	SIG_LINE_STATUS_Error=128,
	SIG_RING_DETECT_Error=512
}*pDHCOM_UARTWEventEnum;

typedef enum DHCOM_CANEnum
{
	DHCOM_CAN1=1,
	DHCOM_CAN_NOT_DEFINED
}*pDHCOM_CANEnum;

typedef enum DHCOM_CANModeEnum
{
	DHCOM_CAN_STANDARD=0,
	DHCOM_CAN_EXTENDED
}*pDHCOM_CANModeEnum;

typedef enum DHCOM_CANFrameEnum
{
	DHCOM_CAN_DATA=0,
	DHCOM_CAN_REMOTE
}*pDHCOM_CANFrameEnum;

//------------------------------------------------------------------------------
// Defines
//------------------------------------------------------------------------------
#define BSP_VERSION_NUMBER				TEXT("BSPVersionNumber")
#define BSP_VERSION_REG_PATH			TEXT("Ident")
#define WINCE_IMAGE_VERSION_NUMBER		TEXT("ImageVersionNumber")
#define WINCE_IMAGE_VERSION_REG_PATH	TEXT("Ident")

//------------------------------------------------------------------------------
// Private functions of the DHHalLib.dll
//------------------------------------------------------------------------------
// Convert Gpio Pin
DWORD ConvertGPIO(DHCOM_GPIOEnum eDHCOMGpio, GPIOConvertType eGPIOType);

//------------------------------------------------------------------------------
// Exported functions of the DHHalLib.dll
//------------------------------------------------------------------------------
// Version Numbers
// ---------------
// Returns the DHHalLib Version
DHHALLIB_API unsigned long DHHalLibGetVersion();
// Returns the BWP Version Version
DHHALLIB_API unsigned long BSPGetVersion();
// Returns the WinCE Image Version
DHHALLIB_API unsigned long WinCEImageGetVersion();

// GPIO
// ----
// Sets the GPIO Pin direction
DHHALLIB_API bool GPIOSetDirection(DHCOM_GPIOEnum eGpio, bool bInOut, bool bDefaultState);
// Sets the GPIO Pin state
DHHALLIB_API void GPIOSetPin(DHCOM_GPIOEnum eGpio, bool bState);
// Returns the current GPIO Pin state
DHHALLIB_API bool GPIOGetPin(DHCOM_GPIOEnum eGpio);
// Set the GPIO Pin Permanent Interrupt
DHHALLIB_API bool GPIOSetInterrupt(DHCOM_GPIOEnum eGpio, DHCOM_GPIOISRType eISRType, HANDLE hEvent);
// Clear the GPIO Pin Interrupt
DHHALLIB_API bool GPIOClearInterrupt(DHCOM_GPIOEnum eGpio);

// I2C
// ---
// Open I2C port
DHHALLIB_API bool I2COpen(DHCOM_I2CEnum eI2CPort, DHCOM_I2CFREQMode eI2CFreq);
// Close I2C port
DHHALLIB_API void I2CClose(DHCOM_I2CEnum eI2CPort);
// Read 1 Byte from I2C device
DHHALLIB_API bool I2CRead(DHCOM_I2CEnum eI2CPort, DHCOM_I2CFREQMode eI2CFreq, unsigned char cDevId, unsigned char cI2CReg, unsigned char *pOutBuffer);
// Read multiple Bytes from I2C device
DHHALLIB_API bool I2CReadMultipleBytes(DHCOM_I2CEnum eI2CPort, DHCOM_I2CFREQMode eI2CFreq, unsigned char cDevId, unsigned char cI2CReg, unsigned char cBytes, unsigned char *pOutBuffer);
// Write 1 Byte to I2C device
DHHALLIB_API bool I2CWrite(DHCOM_I2CEnum eI2CPort, DHCOM_I2CFREQMode eI2CFreq, unsigned char cDevId, unsigned char cI2CReg, unsigned char cValue);
// Write multiple Bytes to I2C device
DHHALLIB_API bool I2CWriteMultipleBytes(DHCOM_I2CEnum eI2CPort, DHCOM_I2CFREQMode eI2CFreq, unsigned char cDevId, unsigned char cI2CReg, unsigned char cBytes, unsigned char *pInBuffer);

// SPI
// ---
// Open SPI port
DHHALLIB_API bool SPIOpen(DHCOM_SPIEnum eSPIPort);
// Close SPI port
DHHALLIB_API void SPIClose(DHCOM_SPIEnum eSPIPort);
// Configure SPI port
DHHALLIB_API bool SPIConfigure(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, unsigned int iSPIFreq, bool useDMA);
// Write/Read (Exchange) SPI port
DHHALLIB_API bool SPIExchange(DHCOM_SPIEnum eSPIPort, int iBitCount, unsigned long *pOutBuffer, unsigned long *pInBuffer);

// UART
// ---
// Open UART port
DHHALLIB_API bool UARTOpen(DHCOM_UARTEnum eUARTPort, DHCOM_UARTModeEnum eUARTMode, unsigned long lUARTFreq);
// Close UART port
DHHALLIB_API void UARTClose(DHCOM_UARTEnum eUARTPort);
// Configure UART port parameters
DHHALLIB_API bool UARTConfigure(DHCOM_UARTEnum eUARTPort, DHCOM_UARTModeEnum eUARTMode, DHCOM_UARTParityEnum eUARTParity, DHCOM_UARTStopBitEnum eUARTStopBit, DHCOM_UARTByteSizeEnum eUARTByteSize, unsigned long lUARTFreq);
// Configure UART port timeout
DHHALLIB_API bool UARTConfigureTimeout(DHCOM_UARTEnum eUARTPort, unsigned long lReadIntervalTimeout, unsigned long lReadTotalTimeoutConstant, unsigned long lReadTotalTimeoutMultiplier, unsigned long ulWriteTotalTimeoutConstant, unsigned long ulWriteTotalTimeoutMultiplier);
// Clear UART port buffers
DHHALLIB_API bool UARTClearBuffer(DHCOM_UARTEnum eUARTPort);
// Read from UART device
DHHALLIB_API bool UARTRead(DHCOM_UARTEnum eUARTPort, int iDataLength, unsigned char *pInBuffer);
// Write to UART device
DHHALLIB_API bool UARTWrite(DHCOM_UARTEnum eUARTPort, unsigned char *pOutBuffer);

// CAN
// ---
// Open CAN port
DHHALLIB_API bool CANOpen(DHCOM_CANEnum eCANPort);
// Close CAN port
DHHALLIB_API void CANClose(DHCOM_CANEnum eCANPort);
// Configure CAN port parameters
DHHALLIB_API bool CANConfigureMode(DHCOM_CANEnum eCANPort, DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate = 0, bool bCANTLPrio = false, bool bCANLoopback = false);
// Configure CAN port timeout
DHHALLIB_API bool CANConfigureTiming(DHCOM_CANEnum eCANPort, unsigned long lPrescaler, unsigned char cPropSeg, unsigned char cPhase1Seg, unsigned char cPhase2Seg, unsigned char RJW);
// Configure CAN filter port parameters
DHHALLIB_API bool CANConfigureFilter(DHCOM_CANEnum eCANPort, int iFilterID, int iFilterIDMask, bool bFilterFormat, bool bFilterRemote);
// Remove CAN filter port parameters
DHHALLIB_API bool CANResetFilter(DHCOM_CANEnum eCANPort);
// Configure CAN message parameters
DHHALLIB_API bool CANConfigureMessage(DHCOM_CANEnum eCANPort, DHCOM_CANFrameEnum eCANFrame, int iCANMsgID, unsigned char cCANMsgPrio, unsigned long lCANMsgTimeout, bool bReadWrite);
// Get CAN message parameters
DHHALLIB_API bool CANGetMessageParameter(DHCOM_CANEnum eCANPort, int *iCANMsgID, int *iCANMsgLength = 0, int *iCANFrame = 0, unsigned char *cCANMsgPrio = 0, unsigned long *lCANMsgTimeout = 0, int *iTXAbort = 0, bool bReadWrite = false);
// Read Data/Remote from CAN device
DHHALLIB_API bool CANRead(DHCOM_CANEnum eCANPort, unsigned char *pInBuffer, int iDataLength, int *iResult);
// Write Data/Remote to CAN device
DHHALLIB_API bool CANWrite(DHCOM_CANEnum eCANPort, unsigned char *pOutBuffer, int iDataLength, int *iResult);

// Memory
// ------
// Writes value to specified phy. address
DHHALLIB_API int WritePhysicalAddress(DHCOM_PHYEnum PHYDev, unsigned long ulPhyAddr, unsigned char cRegSize, int iValue, bool bReadBack = false);
// Read from the specified phy. address
DHHALLIB_API int ReadPhysicalAddress(DHCOM_PHYEnum PHYDev, unsigned long ulPhyAddr, unsigned char cRegSize);

// KITL Control
// ------------
// Restart KITL Connection Power
DHHALLIB_API bool RestartPowerKITL();
// Control KITL Connection Power
DHHALLIB_API bool ControlPowerKITL(bool bEnable);

// PWM
// ------
// Set DHCOM Backlight Level
DHHALLIB_API bool SetBacklightLevel(int iLevel);
// Set DHCOM Backlight Suspend
DHHALLIB_API bool SetBacklightSuspend(int Timeout, bool bEnable);

// Touch Screen
// ------------
// Start's the Touch Screen Calibration
DHHALLIB_API bool CalibrateTouch();	
// Clear's the Touch Calibration data
DHHALLIB_API bool ClearTouchCalibrationData();

// Watchdog & Reset
// ----------------
// Performs a software reset
DHHALLIB_API void SoftReset();	

// Registry
// --------
// Stores the registry permanent
DHHALLIB_API bool SaveRegistry();
// Creates Registry backup files on Storage Card
DHHALLIB_API bool CreateRegistryBackup();
// Restores Registry backup files from Storage Card and restarts CPU
DHHALLIB_API bool RestoreRegistryBackup();

#endif
